#goal: create list of donor / acceptor sites from potential fusion events
#blat list of donor, list of acceptor, and entire sequence to hg19
#Tess Jeffers
#11/02/2010

import sys
import commands
import os

#desired function call: python blatJunct.py <fusion.junction file>
#creates <fusion.out> file with all blat results
########################################################################################
def write_fa(junctions):
    input = open(junctions)
    line = input.readline()
    line = input.readline()
    fn = ("%s%s" % (filePrefix, ".fa"))
    fnop = open(fn, "w")

    while line != "":
        tab = line.split("\t")
        seq = tab[13]
        length = int(len(seq))
        mid = length/2
        #blatting k-mer is 50 nt long
        start= int(mid-50)
        stop = int(mid+50)
        donor = seq[start:mid]
        acceptor = seq[mid:stop]
        junction = tab[3]
        fnop.write("%s%s%s%s%s%s" % (">", junction, "donor", "\n", donor, "\n"))
        fnop.write("%s%s%s%s%s%s" % (">", junction, "acceptor", "\n", acceptor, "\n"))
            #append donor, acceptor to a .fa file, with name
            #submit blat
        line = input.readline()
    fnop.close()
    return fn

def submit_blat(fn, blat_chrom):
    fnop = open(fn, "r")
    outfile = " " + filePrefix+ ".out"
    print blat_chrom
    cmd = "%s%s %s%s" % ("blat -stepSize=5 -repMatch=2253 -minScore=0 -minIdentity=0 -out=blast8 ", blat_chrom, fn, outfile)
    print cmd
    p = commands.getoutput(cmd)
    fnop.close()
    return p

########################################################################################
path = os.path.splitext(sys.argv[1])
filePrefix = path[0]

fn = write_fa(sys.argv[1])
out = submit_blat(fn, sys.argv[2])


